module AlgoExamples where

import SCons
import Data.Ratio ((%))

testRnd0 :: RSpec
testRnd0 = RSpec "inp" AllToLdr [Upd (1%2) SmaxTS "eph", Upd (3%4) SmaxTS "tst"]

paxosRnd0 :: RSpec
paxosRnd0 = RSpec "inp" AllToLdr [Upd (1%2) SmaxTS "eph"]

paxosRnd1 :: RSpec
paxosRnd1 = RSpec "eph" LdrToAll [Upd 0 Any "inp", Upd 0 Any "eph"]

paxosRnd2 :: RSpec
paxosRnd2 = RSpec "eph" AllToLdr [Upd (1%2) Any "eph"]

paxosRnd3 :: RSpec
paxosRnd3 = RSpec "eph" LdrToAll [Upd 0 Any "dec"]

paxosPhiTerm = [[[PhiLR (1%2)], [PhiLS], [PhiLR (1%2)], [PhiLS]]]

paxos = Algo
        Timestamped
        [paxosRnd0, paxosRnd1, paxosRnd2, paxosRnd3]
        (replicate 4 [])
        paxosPhiTerm
        
ct = Algo Timestamped
        [paxosRnd0, paxosRnd1, paxosRnd2, paxosRnd3]
        [[PhiLR (1%2)], [], [], []]
        paxosPhiTerm

paxos2Rnd0 :: RSpec
paxos2Rnd0 = RSpec "inp" AllToLdr [Upd (1%2) SmaxTS "eph"]

paxos2Rnd1 :: RSpec
paxos2Rnd1 = RSpec "eph" LdrToAll [Upd 0 Any "inp", Upd 0 Any "eph"]

paxos2Rnd2 :: RSpec
paxos2Rnd2 = RSpec "eph" AllToAll [Upd (1%2) Any "dec"]

flexiblePaxosRnd0 :: RSpec
flexiblePaxosRnd0 = RSpec "inp" AllToLdr [Upd (2%3) SmaxTS "eph"]

flexiblePaxosRnd1 :: RSpec
flexiblePaxosRnd1 = RSpec "eph" LdrToAll [Upd 0 Any "inp", Upd 0 Any "eph"]

flexiblePaxosRnd2 :: RSpec
flexiblePaxosRnd2 = RSpec "eph" AllToLdr [Upd (1%3) Any "eph"]

flexiblePaxosRnd3 :: RSpec
flexiblePaxosRnd3 = RSpec "eph" LdrToAll [Upd 0 Any "dec"]

flexiblePaxosPhiTerm = [[[PhiLR (2%3)], [PhiLS], [PhiLR (1%3)], [PhiLS]]]

flexiblePaxos = Algo
        Timestamped
        [flexiblePaxosRnd0, flexiblePaxosRnd1, flexiblePaxosRnd2, flexiblePaxosRnd3]
        (replicate 4 [])
        flexiblePaxosPhiTerm
 
newAlgo = Algo Timestamped
  [RSpec "inp" AllToAll [Upd (1%2) SmaxTS "eph"]
  , RSpec "eph" AllToAll
    [Upd (1%2) AllEq "eph"
     , Upd (1%2) AllEq "inp"
    ]
  , RSpec "eph" AllToAll [Upd (1%2) Any "dec"]
  ]
  (replicate 3 [])
  [[[PhiT (1%2), PhiU], [PhiT (1%2)], [PhiT (1%2)]]]

otr = Algo Normal
  [RSpec "inp" AllToAll
   [Upd (2%3) AllEq "dec"
   , Upd (2%3) Smor "inp"]]
   [[]]
   [[[PhiT (2%3), PhiU]], [[PhiT (2%3)]]]

cuv = Algo Normal
  [RSpec "inp" LdrToAll
    [Upd 0 Any "inp"]
   , RSpec "inp" AllToAll
     [Upd (1%2) AllEq "eph"]
   , RSpec "eph" AllToAll
     [Upd (1%2) AllEq "dec"
     , Upd 0 Any "inp"]]
  [[], [], [PhiT (1%2)]]
  [[[PhiLS], [PhiT (1%2)], [PhiT (1%2)]]]


scuv = Algo Normal
  [RSpec "inp" LdrToAll
    [Upd 0 Any "eph"]
   , RSpec "eph" AllToAll
     [Upd (1%2) AllEq "dec"
     , Upd 0 Any "inp"]]
  [[], [PhiT (1%2)]]
  [[[PhiLS], [PhiT (1%2)]]]

uvVariant = Algo Normal
  [RSpec "inp" AllToAll
    [Upd (1%2) Smin "inp"]
   , RSpec "inp" AllToAll
     [Upd (1%2) AllEq "eph"]
   , RSpec "eph" AllToAll
     [Upd (1%2) AllEq "dec"
     , Upd 0 Any "inp"]]
  [[], [], [PhiT (1%2)]]
  [[[PhiU, PhiT (1%2)], [PhiT (1%2)], [PhiT (1%2)]]]



benOrRnd1 :: RSpec
benOrRnd1 = RSpec "vote" AllToAll [Upd (1%2) AllEq "dec", Upd 0 Any "inp"]

benOrPhi1 :: RFormula
benOrPhi1 = [PhiT (1%2)]
