{-# LANGUAGE QuasiQuotes, OverloadedStrings, ScopedTypeVariables #-}
module Promela.ChooseRandomness where

import SCons
import qualified Data.Text as T
import Promela.FromFile
import Promela.Promela
import Promela.VarNames

chooseRandomness :: Algo -> T.Text
chooseRandomness a = T.append
                     [fromFile|src/Promela/fragments/draw_randomness.pml|]
                       [fromFile|src/Promela/fragments/cleanup_randomness.pml|]
    where
      rnds = a_rounds a
      rndsWithInp = filter ((inpName `elem`) . specUpdFields . snd) $ zip [0..] rnds
      randRnds = map fst $ rndsWithInp
      randConds :: [String]
      randConds = map (pEq "rnd" . show) randRnds
      randCond = foldr pOr "false" randConds
