module Promela.Generator where

import Promela.VarNames
import Promela.Declarations
import Promela.CalculateUpdates
import Promela.ApplyUpdates
import Promela.ChooseUpdates
import Promela.ChooseRandomness
import Promela.UpdateDecs
import Promela.Cleanup
import Promela.Driver
import Promela.Spec

import Text.Printf (printf)
import Data.List (intercalate, elemIndex)
import Data.Maybe (fromJust)
import SCons
import qualified Data.Text as T

generateModel :: Algo -> T.Text
generateModel a = T.unlines [
  generateDeclarations a
  , generateUpdates a
  , applyUpdates a
  , chooseUpdates a
  , chooseRandomness a
  , updateDecs a
  , generateCleanup a
  , generateDriver a
  , generateSpec a
  ]
                

{-


macros

variable declarations

if needed, swap (if max_ts used)

for each round r in the phase:
calc_r_updates

reset_updates

compact_timestamps (if max_ts used)

for each round r in the phase:

apply_r_updates and clean up (move cleanup here)
(if dec updated, update ex_d0 and ex_d1 here)

main process:
- randomly draw initial input values
- main loop:
  - at the start of phase:
    - choose leader if used
    - choose phase predicate(s)
- calculate for the round updates (move case distinction here)
- case distinction per-round
  - draw the update randomness
  - call the update function

-}
