{-# LANGUAGE QuasiQuotes #-}

module Promela.Spec where

import SCons
import Promela.FromFile
import Promela.VarNames
import Promela.Promela
import qualified Data.Text as T


generateSpec :: Algo -> T.Text
generateSpec a = [fromFile|src/Promela/fragments/spec.pml|]
  where
    nrPhiTs = length (a_term a)
    phiTs
      | isRand a = "phi_lucky" : map phiName [1..nrPhiTs]
      | otherwise = map phiName [1..nrPhiTs]
    termFormula :: String
    termFormula
      | nrPhiTs > 1 = foldr (\p q ->
                                pSGlobally $
                                pSImp p (pSGlobally (pSImp "start" q))) ex_dec
                      phiTs
      | otherwise = foldr (\p q -> pSGlobally $ pSImp p q) ex_dec phiTs
                      
    -- TODO: replace this with all_dec? Actually not necessary,
    -- due to the theorem that we prove, at least with (R6): whenever
    -- we have a trace where one doesn't decide, we get a trace where
    -- nobody decides
    ex_dec = pSEventually $ pOr "ex_d0" "ex_d1"
